<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE>L-Systems</TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 1.1.5  (Linux)">
	<META NAME="CREATED" CONTENT="20070629;20215000">
	<META NAME="CHANGED" CONTENT="20070710;15273100">
</HEAD>
<BODY LANG="en-US" DIR="LTR">
<P STYLE="margin-bottom: 0in"><FONT SIZE=6><B>How to Build and Use an
L-System</B></FONT></P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><BR>
</H2>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in">Contents</H2>
<P STYLE="margin-bottom: 0in"><A HREF="#definition"><U>Definition</U></A><U><BR></U><A HREF="#create"><U>Create
Your First L-Systems</U></A><U><BR></U><A HREF="#key"><U>Key for
Special L-System Symbols</U></A></P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="definition"></A>
Definition</H2>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">L-systems differ from
Chomsky grammars in that all variables are replaced in each step, and
not just one. For example, with the replacement rule “G → g G G
f”, and with an axiom, or initial state, of “G G”, the first
derivation,of the system would be “g G G f g G G f”. the second
derivation “g g G G f g G G f f g g G G f g G G f f”, and so on. 
</P>
<P STYLE="margin-bottom: 0in; font-weight: medium"><FONT SIZE=3>JFLAP
defines an L-System as follows: <BR>Σ is the finite alphabet of the
L-system.</FONT></P>
<P STYLE="margin-bottom: 0in; font-weight: medium"><FONT SIZE=3>A ∈
Σ+ of the finite length of the axiom</FONT></P>
<P STYLE="margin-bottom: 0in">R = {(a, b, c) → d | a, c ∈ Σ<SUP>*</SUP>,
b ∈ Σ, d ⊂ Σ<SUP>*</SUP>}</P>
<P STYLE="margin-bottom: 0in">For any (a, b, c) → d ∈ R, if |d| &gt;
1 the L-system is a stocastic L-system, and if a ≠λor c ≠λthe
L-system is a contextual L-system. 
</P>
<P STYLE="margin-bottom: 0in">Note: In JFLAP, all unique symbols are
separated by spaces. This means that entering “g g” would be
considered as representing two unique instances of “g”, and
entering “gg” would be considered one instance of the unique
symbol “gg”. This is in contrast to how JFLAP implements other
tools such as grammars, in which every symbol is processed
separately.</P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="create"></A>Creating
L-Systems</H2>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">To create a new L-System,
start JFLAP and click the <B>L-System</B> option from the menu, as
shown below:</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/mainmenu" NAME="Graphic2" ALIGN=MIDDLE WIDTH=233 HEIGHT=321 BORDER=0></P>
<P STYLE="margin-bottom: 0in">One should then see the screen below.
Notice the three parts of the window that will be important for
entering our L-system. The first is the “axiom” area, which
consists of the “Axiom:” label in the upper-left of the screen
and the text box to the right of it. The second is the panel below
the axiom area, which is where we will enter the replacement rules
for our L-system. Finally, the third part is the panel with the
“name” and “parameter” columns, where one can change any
parameters used in animating the L-system.</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/intro" NAME="Graphic1" ALIGN=MIDDLE WIDTH=600 HEIGHT=512 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now, let's enter our first
L-system. Enter “X” for the axiom, and “X → g g g X + g” as
a replacement rule, or load the file <A HREF="lsystem1.jff">lsystem1.jff</A>.
You should see the screen below:</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/input1" NAME="Graphic11" ALIGN=MIDDLE WIDTH=600 HEIGHT=512 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">When finished, click on the
“Input → Render System” command in the menu bar. The following
screen should come up:</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/introanimation" NAME="Graphic3" ALIGN=MIDDLE WIDTH=600 HEIGHT=512 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">There are many things to
notice on this animation screen. The large middle area is where the
animation will occur. There is nothing there at present, but there
will be at higher derivations. The bar in the upper left tracks how
long it takes for the current L-system to load. In lower derivations
JFLAP takes little time, although it takes more at higher ones. The
middle of the upper bar shows the axiom at the current derivation.
Since the screen is currently in the zeroth derivation, there is just
an “X”. In the upper right there is a derivation spinner, set at
“0”, which allows the user to adjust the current derivation.
Let's use that now. Use it to change to the first, second, and third
derivations. With each derivation, you should see drawings and axioms
resembling the ones below:</P>
<TABLE WIDTH=100% BORDER=1 CELLPADDING=4 CELLSPACING=3>
	<COL WIDTH=85*>
	<COL WIDTH=85*>
	<COL WIDTH=85*>
	<THEAD>
		<TR VALIGN=TOP>
			<TH WIDTH=33%>
				<P><U>Derivation 1</U></P>
			</TH>
			<TH WIDTH=33%>
				<P><U>Derivation 2</U></P>
			</TH>
			<TH WIDTH=33%>
				<P><U>Derivation 3</U></P>
			</TH>
		</TR>
	</THEAD>
	<TBODY>
		<TR VALIGN=TOP>
			<TD WIDTH=33%>
				<P ALIGN=CENTER><IMG SRC="images/derivation1_1" NAME="Graphic4" ALIGN=MIDDLE WIDTH=231 HEIGHT=320 BORDER=0></P>
			</TD>
			<TD WIDTH=33%>
				<P ALIGN=CENTER><IMG SRC="images/derivation1_2" NAME="Graphic5" ALIGN=MIDDLE WIDTH=225 HEIGHT=319 BORDER=0></P>
			</TD>
			<TD WIDTH=33%>
				<P ALIGN=CENTER><IMG SRC="images/derivation1_3" NAME="Graphic6" ALIGN=MIDDLE WIDTH=202 HEIGHT=319 BORDER=0></P>
			</TD>
		</TR>
	</TBODY>
</TABLE>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">In the first derivation, we
can see a line, part of which veers to the upper right. This is drawn
by what is termed a “turtle”, which draws the commands given to
it. You may wonder what exactly these commands are. There are two
unique commands in the example above that we have given the turtle,
“g” and “+”. “g” tells the turtle to move forward a
preset distance with the pen down, meaning that it draws a line as it
moves forward. “+” tells the turtle to turn right a few degrees,
in this case the default 15&deg;. Through the three derivations, we
can see what happens as each time the X is replaced by new symbols
and the graph interprets them. The line gets longer and curves more
the higher the derivation is, due to the presence of more “g” and
“+” symbols. Other characters, such as the “X”, have no
effect on the turtle as it processes a derivation.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now is a good time to notice
the “Pitch”, “Roll”, and “Yaw” spinners in the lower part
of the screen. These will rotate your drawing in a specified
direction in 15&deg; increments, depending on the particular spinner.
The “Pitch” will rotate the object around the x-axis, the “Roll”
around the y-axis, and the “Yaw” around the z-axis (defining the
x-axis as the horizontal axis, the y-axis as the vertical one, and
the z-axis as the implicit axis perpendicular to the screen). Go
ahead and rotate the image as you see fit. Notice that a spinner
cannot be less than 0&deg; nor greater than 345&deg;.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Let's try a different
example. Close the current animation, and either enter the
information found in the screen below, or load the file <A HREF="lsystem2.jff">lsystem2.jff</A>.
When finished, you should see the screen below...</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/input2" NAME="Graphic7" ALIGN=MIDDLE WIDTH=600 HEIGHT=512 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">The first rule has three new
symbols. The “~” symbol decrements the width in lines drawn by
the turtle. The “[“ and “]” symbols store the symbols between
them and state of the turtle (position &amp; parameter values) on a
stack for processing later. The turtle continues with processing
symbols following the “]”, and will eventually come back to
process the brackets and the symbols between them with the saved
state of the turtle. This allows for the user to create a branch. You
may also now notice that we are entering new parameters in the bottom
panel. These will overwrite the default values for the animation. For
example, instead of the turtle moving 15&deg; to the right when a “+”
is read, it will now move 30&deg; thanks to the new value under the
“angle” parameter. Now, let's try out our new L-system. When you
render it, you will notice that it draws a fairly thick line with
small spurs issuing from it in 30&deg; intervals. The following is a
picture of the screen in the tenth derivation.</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/derivation2_10" NAME="Graphic8" ALIGN=MIDDLE WIDTH=600 HEIGHT=512 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Let's do one final example.
This time, we are going to make and draw a tree. Close the current
animation, and either enter the information found in the screen
below, or load the file <A HREF="tree.jff">tree.jff</A>. When
finished, you should see the screen below...</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/inputtree" NAME="Graphic9" ALIGN=MIDDLE WIDTH=600 HEIGHT=512 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">We are using a number of
different symbols that we haven't used before. For example, the
symbol “%” rotates the turtle 180&deg;. The “{“ and “}”
operators allow one to fill in solid polygons, with each new position
reached by “g” a vertex. The ## and @@ operators increment and
decrement the hue colors of the polygon, respectively. When rendered,
after a suitable number of derivations you should notice a tree that
has different colors the higher it gets. A drawing of the tree in the
tenth derivation is shown below. This is the last example, but please
note the key below which explains the turtle commands that JFLAP
recognizes.</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/derivation3_10" NAME="Graphic10" ALIGN=MIDDLE WIDTH=784 HEIGHT=775 BORDER=0></P>
<H2 ALIGN=LEFT STYLE="margin-top: 0in; margin-bottom: 0in"><BR>
</H2>
<H2 ALIGN=LEFT STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="key"></A>
Key for Special L-System Symbols</H2>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><U>Symbols</U><SPAN STYLE="text-decoration: none">
</SPAN>
</P>
<UL>
	<LI><P ALIGN=LEFT STYLE="margin-bottom: 0in">g → move forward one
	unit with the pin down</P>
	<LI><P ALIGN=LEFT STYLE="margin-bottom: 0in">f → move forward one
	unit with the pin up (note: does not establish a polygon vertex)</P>
	<LI><P ALIGN=LEFT STYLE="margin-bottom: 0in">+ → yaw the turtle
	right by <I>angle</I> degrees (aka turn right along the xy plane)</P>
	<LI><P ALIGN=LEFT STYLE="margin-bottom: 0in">- → yaw the turtle
	left by <I>angle</I> degrees (aka turn left along the xy plane)</P>
	<LI><P ALIGN=LEFT STYLE="margin-bottom: 0in">&amp; → pitch the
	turtle down by <I>angle</I> degrees</P>
	<LI><P ALIGN=LEFT STYLE="margin-bottom: 0in">^ → pitch the turtle
	up by <I>angle</I> degrees</P>
	<LI><P ALIGN=LEFT STYLE="margin-bottom: 0in">/ → roll the turtle
	to the right by <I>angle</I> degrees</P>
	<LI><P ALIGN=LEFT STYLE="margin-bottom: 0in">* → roll the turtle
	to the left by <I>angle</I> degrees</P>
	<LI><P ALIGN=LEFT STYLE="margin-bottom: 0in">% → change direction
	180 degrees</P>
	<LI><P ALIGN=LEFT STYLE="margin-bottom: 0in">! → increment the
	width of the next lines</P>
	<LI><P ALIGN=LEFT STYLE="margin-bottom: 0in">~ → decrement the
	width of the next lines</P>
	<LI><P ALIGN=LEFT STYLE="margin-bottom: 0in">[ → save in stack
	current state info</P>
	<LI><P ALIGN=LEFT STYLE="margin-bottom: 0in">] → recover from
	stack state info</P>
	<LI><P ALIGN=LEFT STYLE="margin-bottom: 0in">{ → start filled in
	polygon</P>
	<LI><P ALIGN=LEFT STYLE="margin-bottom: 0in">} → end filled in
	polygon</P>
	<LI><P ALIGN=LEFT STYLE="margin-bottom: 0in"># → increment the
	huge angle of <I>color</I> by <I>hueChange</I></P>
	<LI><P ALIGN=LEFT STYLE="margin-bottom: 0in">@ → decrement the
	huge angle of <I>color</I> by <I>hueChange</I></P>
	<LI><P ALIGN=LEFT STYLE="margin-bottom: 0in">## → increment the
	huge angle of <I>polygonColor</I> by <I>hueChange</I></P>
	<LI><P ALIGN=LEFT STYLE="margin-bottom: 0in">@@ → decrement the
	huge angle of <I>polygonColor</I> by <I>hueChange</I></P>
</UL>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><U>Parameters</U></P>
<UL>
	<LI><P ALIGN=LEFT STYLE="margin-bottom: 0in"><I>color → </I>the
	color of the line (default is black).</P>
	<LI><P ALIGN=LEFT STYLE="margin-bottom: 0in"><I>polygonColor → </I>the
	color with which polygons are filled (default is red)</P>
	<LI><P ALIGN=LEFT STYLE="margin-bottom: 0in"><I>distance → </I>the
	amount the <I>g </I>and <I>f </I>commands move the turtle forward
	(default is 15 pixels)</P>
	<LI><P ALIGN=LEFT STYLE="margin-bottom: 0in"><I>angle → </I>amount
	the turtle turns, pitches, or rolls when commanded (default is 15)</P>
	<LI><P ALIGN=LEFT STYLE="margin-bottom: 0in"><I>lineWidth → </I>pixel
	length width of the line (default is 1.0 pixels)</P>
	<LI><P ALIGN=LEFT STYLE="margin-bottom: 0in"><I>lineIncrement →
	</I>amount the width of the line is incremented or decremented when
	commanded (default is 1.0 pixels)</P>
	<LI><P ALIGN=LEFT STYLE="margin-bottom: 0in"><I>hueChange → </I>amount
	the hue of the current drawing color is incremented when given the
	command (default is 10)</P>
</UL>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><U>Colors</U></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">One may specify a new color
by a, b, and c by three values separated by commas. If the values are
between 0.0 and 1.0, they are interpreted as hue, saturation, and
brightness. If outside that range, they will be considered as a
standard red, green, blue color scheme ranging from 0 to 225. Blue,
for example, is both 0.667, 1, 1 and 0, 0, 255. Concerning built-in
colors, the following colors are built into JFLAP. They are case
sensitive:</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><I>black, blue, brown, cyan,
darkGray, darkOliveGreen, darkOliveGreen2, dukeBlue, froestGreen,
goldenrod, gray, green, lightGray, magenta, maroon, oliveDrab,
orange, orangeRed, pink, purple, red, springGreen, violetRed, white,</I>
and <I>yellow</I></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><B>This concludes our brief
tutorial on building L-systems. Thanks for reading!</B></P>
</BODY>
</HTML>
